# Alert-Me Display

A simple application for an
[nRF52840](https://www.nordicsemi.com/Products/nRF52840) microcontroller using
[embassy](https://embassy.dev/).

It consists of multiple parts:

- Configuration interface leveraging BLE
- Connect to WiFi in order subscribe to a configured MQTT topic
- Show information on an LCD screen

This is a learning environment, not a finished product.

# Development

## Nix

If using the nix way as described in the [top-level readme](../README.md), no
further dependencies need to be installed.

## Manual Way

In addition to the [top-level readme](../README.md) dependencies, the following
has to be installed:

- [probe-rs](https://probe.rs/docs/getting-started/installation/)

## Softdevice

The softdevice blob is not distributed with this repository for licensing
reasons (even though my understanding is that it is possible).

Download the
[S140 Softdevice](https://www.nordicsemi.com/Products/Development-software/s140/download)
and flash it to your chip.

_Example command to flash the softdevice_

```
probe-rs download --verify --format hex --chip nRF52840_xxAA ./s140_nrf52_7.3.0_softdevice.hex
```

## Running

Verify that the microcontrolleris recognized by running `probe-rs list`.

A simple `cargo run` will then connect to it and upload the code. Logging output
should be visible.
